"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var React = _interopRequireWildcard(require("react"));

var _Icon = require("./Icon");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function Button(_ref) {
  let {
    className,
    disabled,
    label,
    icon,
    busy,
    active,
    type,
    acceptFocus,
    children,
    variant = 'primary',
    spinner = _Icon.Spinner,
    component: Tag = 'button'
  } = _ref,
      props = _objectWithoutProperties(_ref, ["className", "disabled", "label", "icon", "busy", "active", "type", "acceptFocus", "children", "variant", "spinner", "component"]);

  if (Tag === 'button') type = type || 'button';
  return React.createElement(Tag, Object.assign({}, props, {
    title: label,
    type: type,
    tabIndex: !acceptFocus ? -1 : undefined,
    disabled: disabled,
    "aria-disabled": disabled,
    "aria-label": label,
    className: (0, _classnames.default)(className, 'rw-btn', !acceptFocus && 'rw-outline-none', active && !disabled && 'rw-state-active', variant && 'rw-btn-' + variant)
  }), busy ? spinner : icon, children);
}

var _default = Button;
exports.default = _default;