import React from 'react';
import { InputProps } from './Input';
import { Localizer, RequiredDateMethods } from './Localization';
export interface DateTimePickerInputProps extends Omit<InputProps, "value" | "onChange"> {
    format: RequiredDateMethods;
    editing: boolean;
    editFormat?: string;
    parse: string[] | string | ((str: string) => Date | undefined);
    value?: Date | null;
    onChange: (date: Date | null, rawValue: string) => void;
    onBlur?: (event: React.FocusEvent<HTMLInputElement>) => void;
    localizer: Localizer;
    disabled?: boolean;
    readOnly?: boolean;
}
declare const DateTimePickerInput: React.ForwardRefExoticComponent<DateTimePickerInputProps & React.RefAttributes<HTMLInputElement>>;
export default DateTimePickerInput;
//# sourceMappingURL=DateTimePickerInput.d.ts.map